import { Logger } from '../../../util/logger';
import { DispatcherClient as PbDispatcherClient } from '../../../protoc/dispatcher';
import { Worker } from 'worker_threads';
import { ClientConfig } from '../../hatchet-client';
import { DispatcherClient } from '../dispatcher-client';
export interface HeartbeatMessage {
    type: 'info' | 'warn' | 'error' | 'debug';
    message: string;
}
export declare const STOP_HEARTBEAT = "stop";
export declare class Heartbeat {
    config: ClientConfig;
    client: PbDispatcherClient;
    workerId: string;
    logger: Logger;
    heartbeatWorker: Worker | undefined;
    constructor(client: DispatcherClient, workerId: string);
    start(): Promise<void>;
    stop(): Promise<void>;
}
