import { Channel, ClientFactory } from 'nice-grpc';
import { ClientConfig } from '../../hatchet-client/client-config';
import { Logger } from '../../../util/logger';
import { V1DispatcherClient } from '../../../protoc/v1/dispatcher';
import { SleepMatchCondition, UserEventMatchCondition } from '../../../protoc/v1/shared/condition';
import { Api } from '../../rest';
import { DurableEventGrpcPooledListener } from './pooled-durable-listener-client';
export declare class DurableListenerClient {
    config: ClientConfig;
    client: V1DispatcherClient;
    logger: Logger;
    api: Api;
    pooledListener: DurableEventGrpcPooledListener | undefined;
    constructor(config: ClientConfig, channel: Channel, factory: ClientFactory, api: Api);
    subscribe(request: {
        taskId: string;
        signalKey: string;
    }): import("./pooled-durable-listener-client").DurableEventStreamable;
    registerDurableEvent(request: {
        taskId: string;
        signalKey: string;
        sleepConditions: Array<SleepMatchCondition>;
        userEventConditions: Array<UserEventMatchCondition>;
    }): Promise<import("../../../protoc/v1/dispatcher").RegisterDurableEventResponse>;
}
