"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurableListenerClient = void 0;
const dispatcher_1 = require("../../../protoc/v1/dispatcher");
const pooled_durable_listener_client_1 = require("./pooled-durable-listener-client");
class DurableListenerClient {
    constructor(config, channel, factory, api) {
        this.config = config;
        this.client = factory.create(dispatcher_1.V1DispatcherDefinition, channel);
        this.logger = config.logger(`Listener`, config.log_level);
        this.api = api;
    }
    subscribe(request) {
        if (!this.pooledListener) {
            this.pooledListener = new pooled_durable_listener_client_1.DurableEventGrpcPooledListener(this, () => {
                this.pooledListener = undefined;
            });
        }
        return this.pooledListener.subscribe(request);
    }
    registerDurableEvent(request) {
        if (!this.pooledListener) {
            this.pooledListener = new pooled_durable_listener_client_1.DurableEventGrpcPooledListener(this, () => {
                this.pooledListener = undefined;
            });
        }
        return this.pooledListener.registerDurableEvent(request);
    }
}
exports.DurableListenerClient = DurableListenerClient;
