"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simpleCronWorkflow = void 0;
const sdk_1 = __importDefault(require("../../sdk"));
const hatchet = sdk_1.default.init();
// ❓ Workflow Definition Cron Trigger
// Adding a cron trigger to a workflow is as simple as adding a `cron expression` to the `on` prop of the workflow definition
exports.simpleCronWorkflow = {
    id: 'simple-cron-workflow',
    on: {
        // 👀 define the cron expression to run every minute
        cron: '* * * * *',
    },
    // ... normal workflow definition
    description: 'return the current time every minute',
    steps: [
        {
            name: 'what-time-is-it',
            run: (ctx) => {
                return { time: new Date().toISOString() };
            },
        },
    ],
    // ,
};
// ‼️
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const worker = yield hatchet.worker('example-worker');
        yield worker.registerWorkflow(exports.simpleCronWorkflow);
        worker.start();
    });
}
if (require.main === module) {
    main();
}
