import { BinaryReader, BinaryWriter } from '@bufbuild/protobuf/wire';
import { type CallContext, type CallOptions } from 'nice-grpc-common';
import { DurableEventListenerConditions } from './shared/condition';
export declare const protobufPackage = "v1";
export interface RegisterDurableEventRequest {
    /** external uuid for the task run */
    taskId: string;
    /** the signal key for the event */
    signalKey: string;
    /** the task conditions for creating the task */
    conditions: DurableEventListenerConditions | undefined;
}
export interface RegisterDurableEventResponse {
}
export interface ListenForDurableEventRequest {
    /** single listener per worker */
    taskId: string;
    /** the match id for the listener */
    signalKey: string;
}
export interface DurableEvent {
    taskId: string;
    signalKey: string;
    /** the data for the event */
    data: Uint8Array;
}
export declare const RegisterDurableEventRequest: MessageFns<RegisterDurableEventRequest>;
export declare const RegisterDurableEventResponse: MessageFns<RegisterDurableEventResponse>;
export declare const ListenForDurableEventRequest: MessageFns<ListenForDurableEventRequest>;
export declare const DurableEvent: MessageFns<DurableEvent>;
export type V1DispatcherDefinition = typeof V1DispatcherDefinition;
export declare const V1DispatcherDefinition: {
    readonly name: "V1Dispatcher";
    readonly fullName: "v1.V1Dispatcher";
    readonly methods: {
        readonly registerDurableEvent: {
            readonly name: "RegisterDurableEvent";
            readonly requestType: MessageFns<RegisterDurableEventRequest>;
            readonly requestStream: false;
            readonly responseType: MessageFns<RegisterDurableEventResponse>;
            readonly responseStream: false;
            readonly options: {};
        };
        readonly listenForDurableEvent: {
            readonly name: "ListenForDurableEvent";
            readonly requestType: MessageFns<ListenForDurableEventRequest>;
            readonly requestStream: true;
            readonly responseType: MessageFns<DurableEvent>;
            readonly responseStream: true;
            readonly options: {};
        };
    };
};
export interface V1DispatcherServiceImplementation<CallContextExt = {}> {
    registerDurableEvent(request: RegisterDurableEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<RegisterDurableEventResponse>>;
    listenForDurableEvent(request: AsyncIterable<ListenForDurableEventRequest>, context: CallContext & CallContextExt): ServerStreamingMethodResult<DeepPartial<DurableEvent>>;
}
export interface V1DispatcherClient<CallOptionsExt = {}> {
    registerDurableEvent(request: DeepPartial<RegisterDurableEventRequest>, options?: CallOptions & CallOptionsExt): Promise<RegisterDurableEventResponse>;
    listenForDurableEvent(request: AsyncIterable<DeepPartial<ListenForDurableEventRequest>>, options?: CallOptions & CallOptionsExt): AsyncIterable<DurableEvent>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export type ServerStreamingMethodResult<Response> = {
    [Symbol.asyncIterator](): AsyncIterator<Response, void>;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create(base?: DeepPartial<T>): T;
    fromPartial(object: DeepPartial<T>): T;
}
export {};
