import { RunListenerClient, StepRunEvent } from '../clients/listeners/run-listener/child-listener-client';
import { RunsClient } from '../v1';
type EventualWorkflowRunId = string | Promise<string> | Promise<{
    workflowRunId: string;
}>;
export declare class DedupeViolationErr extends Error {
    constructor(message: string);
}
export default class WorkflowRunRef<T> {
    workflowRunId: EventualWorkflowRunId;
    parentWorkflowRunId?: string;
    private client;
    private runs;
    _standalone_task_name?: string;
    constructor(workflowRunId: string | Promise<string> | Promise<{
        workflowRunId: string;
    }>, client: RunListenerClient, runsClient?: RunsClient, parentWorkflowRunId?: string);
    get runId(): Promise<string>;
    getWorkflowRunId(): Promise<string>;
    stream(): Promise<AsyncGenerator<StepRunEvent, void, unknown>>;
    get output(): Promise<T>;
    /**
     * @alias output
     * @deprecated use output
     */
    result(): Promise<T>;
    toJSON(): Promise<string>;
    cancel(): Promise<void>;
    replay(): Promise<void>;
}
export {};
