import { BaseWorkflowDeclaration } from '../..';
import { Workflow } from '../../../workflow';
import { HatchetClient } from '../client';
/**
 * MetricsClient is used to get metrics for workflows
 */
export declare class MetricsClient {
    tenantId: string;
    api: HatchetClient['api'];
    constructor(client: HatchetClient);
    getWorkflowMetrics(workflow: string | Workflow | BaseWorkflowDeclaration<any, any>, opts?: Parameters<typeof this.api.workflowGetMetrics>[1]): Promise<import("../../../clients/rest/generated/data-contracts").WorkflowMetrics>;
    getQueueMetrics(opts?: Parameters<typeof this.api.tenantGetQueueMetrics>[1] & {}): Promise<import("../../../clients/rest/generated/data-contracts").TenantQueueMetrics>;
    getTaskMetrics(opts?: Parameters<typeof this.api.tenantGetStepRunQueueMetrics>[1]): Promise<import("../../../clients/rest/generated/data-contracts").TenantStepRunQueueMetrics>;
}
