"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetricsClient = void 0;
const v1_1 = require("../..");
/**
 * MetricsClient is used to get metrics for workflows
 */
class MetricsClient {
    constructor(client) {
        this.tenantId = client.tenantId;
        this.api = client.api;
    }
    getWorkflowMetrics(workflow, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const name = (0, v1_1.workflowNameString)(workflow);
            const { data } = yield this.api.workflowGetMetrics(name, opts);
            return data;
        });
    }
    getQueueMetrics(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            // TODO IMPORTANT workflow id is the uuid for the workflow... not its name
            // const stringWorkflows = opts?.workflows?
            const { data } = yield this.api.tenantGetQueueMetrics(this.tenantId, Object.assign({}, opts));
            return data;
        });
    }
    getTaskMetrics(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            // TODO what is this...
            const { data } = yield this.api.tenantGetStepRunQueueMetrics(this.tenantId, opts);
            return data;
        });
    }
}
exports.MetricsClient = MetricsClient;
