import { RateLimitDuration } from '../../../protoc/workflows';
import { RateLimitOrderByField, RateLimitOrderByDirection } from '../../../clients/rest/generated/data-contracts';
import { HatchetClient } from '../client';
export { RateLimitDuration, RateLimitOrderByField, RateLimitOrderByDirection };
export type CreateRateLimitOpts = {
    key: string;
    limit: number;
    duration?: RateLimitDuration;
};
/**
 * RatelimitsClient is used to manage rate limits for the Hatchet
 */
export declare class RatelimitsClient {
    api: HatchetClient['api'];
    admin: HatchetClient['admin'];
    tenantId: string;
    constructor(client: HatchetClient);
    upsert(opts: CreateRateLimitOpts): Promise<string>;
    list(opts: Parameters<typeof this.api.rateLimitList>[1]): Promise<import("../../../clients/rest/generated/data-contracts").RateLimitList>;
}
