import { Workflow } from '../../../workflow';
import { BaseWorkflowDeclaration } from '../..';
import { HatchetClient } from '../client';
export declare const workflowNameString: (workflow: string | Workflow | BaseWorkflowDeclaration<any, any>) => string;
/**
 * WorkflowsClient is used to list and manage workflows
 */
export declare class WorkflowsClient {
    api: HatchetClient['api'];
    tenantId: string;
    private workflowCache;
    private cacheTTL;
    constructor(client: HatchetClient, cacheTTL?: number);
    get(workflow: string | BaseWorkflowDeclaration<any, any> | Workflow): Promise<any>;
    list(opts?: Parameters<typeof this.api.workflowList>[1]): Promise<import("../../../clients/rest/generated/data-contracts").WorkflowList>;
    delete(workflow: string | BaseWorkflowDeclaration<any, any> | Workflow): Promise<void>;
}
