"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parent = exports.child = void 0;
/* eslint-disable no-plusplus */
// ❓ Declaring a Child
const hatchet_client_1 = require("../hatchet-client");
exports.child = hatchet_client_1.hatchet.task({
    name: 'child',
    fn: (input) => {
        return {
            Value: input.N,
        };
    },
});
exports.parent = hatchet_client_1.hatchet.task({
    name: 'parent',
    fn: (input, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        const n = input.N;
        const promises = [];
        for (let i = 0; i < n; i++) {
            promises.push(ctx.runChild(exports.child, { N: i }));
        }
        const childRes = yield Promise.all(promises);
        const sum = childRes.reduce((acc, curr) => acc + curr.Value, 0);
        return {
            Result: sum,
        };
    }),
});
// !!
