"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const workflow_1 = require("./workflow");
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const timeStart = Date.now();
        const res = yield workflow_1.durableSleep.run({});
        const timeEnd = Date.now();
        // eslint-disable-next-line no-console
        console.log(`Time taken: ${timeEnd - timeStart}ms`);
    });
}
if (require.main === module) {
    main()
        .then(() => process.exit(0))
        .catch((error) => {
        // eslint-disable-next-line no-console
        console.error('Error:', error);
        process.exit(1);
    });
}
