"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.durableSleep = void 0;
// import sleep from '../../../util/sleep.js';
const hatchet_client_1 = require("../hatchet-client");
exports.durableSleep = hatchet_client_1.hatchet.workflow({
    name: 'durable-sleep',
});
// ❓ Durable Sleep
exports.durableSleep.durableTask({
    name: 'durable-sleep',
    executionTimeout: '10m',
    fn: (_, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        console.log('sleeping for 5s');
        const sleepRes = yield ctx.sleepFor('5s');
        console.log('done sleeping for 5s', sleepRes);
        return {
            Value: 'done',
        };
    }),
});
// !!
