"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parent = exports.child = void 0;
// ❓ Declaring a Task
const hatchet_client_1 = require("../hatchet-client");
exports.child = hatchet_client_1.hatchet.task({
    name: 'child',
    fn: (input) => {
        return {
            TransformedMessage: input.Message.toLowerCase(),
        };
    },
});
exports.parent = hatchet_client_1.hatchet.task({
    name: 'parent',
    fn: (input, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        const c = yield ctx.runChild(exports.child, {
            Message: input.Message,
        });
        return {
            TransformedMessage: c.TransformedMessage,
        };
    }),
});
// !!
// see ./worker.ts and ./run.ts for how to run the workflow
